
local gr = love.graphics
local pi, sin, cos = math.pi, math.sin, math.cos
local floor = math.floor
local test	= gr.newImage( 'Framed2.jpg')--'Checkerboard2.jpg' )
local wd,ht	= test:getWidth(), test:getHeight()
local steps = 15

function surface()
	local bx, by	= 27, 18	-- nominal x & y sizes before distortion
	local sur		= {}
	local angle		= ( by * pi ) / ( bx * steps )
	for j = 1, steps + 1 do		-- calculate surface
		sur[j] = {}
		for i = 1, steps + 1 do
			sur[j][i] = {
				i * bx * sin( (i-1) * angle ),	-- distorted geometry coordinates
				j * by * sin( (j-1) * angle ),
				(i-1) / (steps-1),			-- undistorted texture coordinates
				(j-1) / (steps-1),
				i * 175 / steps+80,			-- color distortions
				255 - i * 175 / steps,
				j * 255 / steps}
			end
		end
	local gom = {}
	for j = 1, steps do		-- create geometry table
		gom[j] = {}
		for i = 1, steps do
			gom[j][i] = gr.newGeometry(
				{ sur[j][i],		sur[j+1][i],
				  sur[j+1][i+1],	sur[j][i+1]} )
			end
		end
	return gom
	end

local gom2	= surface()

function love.load()
	gr.setMode( 400, 400 )
	gr.setBackgroundColor( 120, 0, 120, 255 )
	gr.setCaption( 'Geometry Test' )
	end

function love.draw()
	for j = 1, steps do
		for i = 1, steps do
			gr.drawq( test, gom2[j][i], 0, 0,0,0.75,0.75 )
			end
		end
	gr.print('Distorted image', 10,190)
	gr.draw( test, 150, 200, 0, 0.25, 0.25 )
	gr.print( 'Original image' ,300,185)
	end

function love.update( dt  ) end

function love.keypressed( key )
	if key == 'escape'	then love.event.quit() end
	end





